unit dataunitmain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  DataController, StdCtrls, ComCtrls, CommunicationServer, QDialogs, helptools;

const separator : char = ' ';

type
  TFormDataController = class(TForm)
    StatusBar1: TStatusBar;
    Button1: TButton;
    MemoLog: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    Controller : TDataController;
    Server : TCommunicationServer;
    procedure ProcessCommand(Sender: TObject; Text: string; ClientName : string);
  public
    { Public declarations }
  end;

var
  FormDataController: TFormDataController;

implementation

{$R *.dfm}

procedure TFormDataController.FormCreate(Sender: TObject);
begin
  Controller := TDataController.Create(self);
  Controller.logpath := '.\log\';
  Controller.configpath := '.\cfg\';
  Controller.logextension := '.dat';
  Controller.cfgextension := '.ini';
  Controller.pictureextension := '.bmp';
  Controller.logfile := 'log';
  Controller.separator := ' ';

  Server := TCommunicationServer.Create(self);
  Server.Port := 10079;
  Server.OnClientReadText := ProcessCommand;
  Server.Start;
end;

procedure TFormDataController.ProcessCommand(Sender: TObject; Text: string; ClientName : string);
var command : string;
    ClientPath : string;
    ClientFileName : string;
    SourceFileName : string;
    helpstring : string;
    list : TStringList;
    i : integer;
    filecount : integer;
begin
  command := ParseString(text,separator);


  if command = 'SAVELOG' then begin
    controller.SaveToLog(text,ClientName);
    memoLog.Lines.Add(text);
  end;


  if command = 'SAVECONFIG' then begin
    controller.SaveToConfig(text,ClientName);
    server.SendText(ClientName,'NEWCONFIGEXISTS');
  end;


  if command = 'READLOG' then begin
    ClientPath := ParseString(text,separator);
    list := controller.ReadFromLog(text,ClientName);
    if list <> nil then begin
      server.SendText(ClientName, StringListToString(list,'|'));

      helpstring := list.Strings[0];
      if ParseString(helpstring,'.',1) = 'bmp' then
        for i := 0 to list.Count - 1 do begin
          helpstring := list.Strings[i];
          SourceFileName := ParseString(helpstring,' ',1);
          helpstring := list.Strings[i];
          ClientFileName := ParseString(helpstring,'\',1);
          server.SendFile(ClientName,SourceFileName,ClientPath + ClientFileName);
          sleep(1000);
        end;
    end
    else
      server.SendText(ClientName, 'CONFIGNOTFOUND');
  end;

  if command = 'READCONFIG' then begin
    list := controller.GiveFileNames(controller.configpath,ClientName+controller.cfgextension);
    ClientPath := text;
    if list <> nil then begin
        ClientFileName := controller.GiveFileNames(controller.configpath,ClientName+controller.cfgextension).Strings[0];
        server.SendFile(ClientName, controller.GiveFileNames(controller.configpath,ClientName+controller.cfgextension).Strings[0],ClientPath + ParseString(ClientFileName,'\',1));
    end
    else
      server.SendText(ClientName,'CONFIGNOTFOUND');
  end;

  if command = 'READCONFIGS' then begin
    list := controller.GiveFileNames(controller.configpath,'*'+controller.cfgextension);
    ClientPath := text;
    if list <> nil then begin
      filecount := controller.GiveFileNames(controller.configpath,'*'+controller.cfgextension).Count;
      for i := 0 to filecount - 1 do begin
        ClientFileName := controller.GiveFileNames(controller.configpath,'*'+controller.cfgextension).Strings[i];
        server.SendFile(ClientName, controller.GiveFileNames(controller.configpath,'*'+controller.cfgextension).Strings[i],ClientPath + ParseString(ClientFileName,'\',1));
      end;
    end;
  end;

end;

procedure TFormDataController.Button1Click(Sender: TObject);
begin
//
end;

end.
