unit helptools;

interface
uses
  SysUtils,Classes;

function StrLeft( SourceStr : PChar; CharNum   : Word): PChar;

function StrRight( SourceStr : PChar; CharNum   : Word): PChar;

function StrSubStr( SourceStr : PChar; StartPos  : Word; CharNum : Word): PChar;

function SubStr( SourceStr : String; StartPos  : Byte; CharNum : Byte): String;

function ParseString(var a : string; breakchar : Char = ' '; invert : integer = 0) : string;

function StringToStringList(line : string; separator : char) : TStringList;

function StringListToString(list : TStringList; separator : char): string;

implementation

function StrLeft( SourceStr : PChar;
                  CharNum   : Word): PChar;
var
   EndNewStr : PChar;
begin
     if ((CharNum < StrLen (SourceStr)) and (SourceStr <> nil)) then
     begin
          EndNewStr  := SourceStr;
          Inc(EndNewStr,CharNum);
          EndNewStr^ := #0;
     end;
     Result := SourceStr;
end;

function StrRight( SourceStr : PChar;
                   CharNum   : Word): PChar;
var
   newStrBegin : PChar;
begin
     NewStrBegin := SourceStr;
     if CharNum < StrLen(SourceStr) then
     begin
          Inc(newStrBegin,StrLen(SourceStr)-CharNum);
     end;
     Result := newStrBegin;
end;

function StrSubStr( SourceStr : PChar;
                    StartPos  : Word;
                    CharNum   : Word): PChar;
var
   newStrBegin : PChar;
begin
     if StrLen(SourceStr) >= StartPos then
     begin
          NewStrBegin := StrRight(SourceStr,StrLen(SourceStr)-StartPos+1);
          Result      := StrLeft(NewStrBegin,CharNum);
     end
     else
     begin
          NewStrBegin  := SourceStr;
          NewStrBegin^ := #0;
          Result       := NewStrBegin;
     end;
end;

function SubStr( SourceStr : String;
                 StartPos  : Byte;
                 CharNum   : Byte): String;
var
   aPChar   : PChar;
   newPChar : PChar;
begin
      aPChar := StrAlloc(Length(SourceStr)+1);
      StrPCopy(aPChar,SourceStr);
      newPChar := StrSubStr(aPChar,StartPos,CharNum);
      Result   := StrPas(newPChar);
      StrDispose(aPChar);
end;


function ParseString(var a : string; breakchar : Char = ' '; invert : integer = 0) : string;
var len,i : integer;
var b : string;
begin
  b := '';
  len := Length(a);
  if invert = 0 then begin
    for i:=0 to len-1 do
      if a[i] = breakchar then break;
  //  i := AnsiStrScan(PChar(a), Char(breakchar));
    if (i <> 0) and (i <> len) then
    begin
      b := SubStr(a,0,i-1); //StrLeft(PChar(a),i-1);
      a := SubStr(a,i+1,len-1); //StrRight(PChar(a),i);
    end;
  end;

  if invert = 1 then begin
    for i:=len-1 downto 0 do
      if a[i] = breakchar then break;
    if (i <> 0) and (i <> len) then
    begin
      b := SubStr(a,i+1,len-1); //StrRight(PChar(a),i);
      a := SubStr(a,0,i-1); //StrLeft(PChar(a),i-1);
    end;
  end;
  Result := b;
end;

function StringToStringList(line : string; separator : char): TStringList;
var list : TStringList;
    i : integer;
    help : string;
begin
  if line = '' then begin
    result := nil;
    exit;
  end;

  list := TStringList.Create;
  while true do begin
    help := ParseString(line, separator);
    if help = '' then
      break;
    list.Add(help);
  end;
  result := list;
  list.Add(line);
end;

function StringListToString(list : TStringList; separator : char): string;
var help : string;
    i : integer;
begin
  if list = nil then begin
    result := '';
    exit;
  end;

  i := 0;
  while i < list.count -1 do begin
    help := help + list.Strings[i];
    help := help + separator;
    i := i + 1;
  end;
  help := help + list.Strings[i];
  result := help;
end;

end.
